from urllib2 import urlopen
from Components.MenuList import MenuList
from Components.Label import Label

from Screens.Screen import Screen
from Screens.MessageBox import MessageBox
from Components.ActionMap import NumberActionMap
from Components.Input import Input
from Components.Pixmap import Pixmap
from Components.FileList import FileList
from Screens.ChoiceBox import ChoiceBox
from Plugins.Plugin import PluginDescriptor
from Components.ActionMap import ActionMap
from Screens.InputBox import InputBox

from twisted.web.client import getPage, downloadPage
from Plugins.Extensions.VlcPlayer.VlcServerConfig import vlcServerConfig

##############################################################
#                                                            #
#   MySpaceViewer : Coded by pcd@dreamforum.nu, July 2009    #
#                                                            #
##############################################################

class Myspace(Screen):
    skin = """
		<screen position="200,200" size="350,100" title="Plugin MySpaceViewer - Search Options" >
			<!--widget name="text" position="0,0" size="550,25" font="Regular;20" /-->
			<widget name="list" position="10,0" size="200,100" scrollbarMode="showOnDemand" />
			<!--widget name="pixmap" position="200,0" size="190,250" /-->
			<eLabel position="70,100" zPosition="-1" size="100,69" backgroundColor="#222222" />
			<widget name="info" position="100,100" zPosition="4" size="100,25" font="Regular;18" foregroundColor="#ffffff" transparent="1" halign="center" valign="center" />

		</screen>"""
    def __init__(self, session):
		self.skin = Myspace.skin
		Screen.__init__(self, session)

        	self["list"] = MenuList([])
		self["info"] = Label()
                self["actions"] = ActionMap(["OkCancelActions"], {"ok": self.okClicked, "cancel": self.close}, -1)

                self.icount = 0
                self.onLayoutFinish.append(self.startSession)

    def startSession(self):
                method =[]
                i = 0
                while i<2:
                      method.append(i)
                      i = i+1
                
                method[0] = "Search direct"
                method[1] = "Select from list"
                self["list"].setList(method)

    def okClicked(self):
         itype = self["list"].getSelectionIndex()
         if itype == 0:
                self.getinput()
         if itype == 1:
                self.session.open(Vlocation)

               
    def getinput(self):                   
                self.session.openWithCallback(self.makeurl, InputBox, title=_("Please enter search words"), maxSize=False, visible_width = 56, type=Input.TEXT)


    def makeurl(self, cline):
         if cline is not None:
                cline = cline.replace ( ' ', '+' )
                url = "http://searchservice.myspace.com/index.cfm?fuseaction=sitesearch.results&orig=search_Header&origpfc=VidsSplash&type=MySpaceTV&qry=" + cline + "&submit=Search";
                self.session.open(Searchurl, url)


class Searchurl(Screen):

    skin = """
		<screen position="100,100" size="550,400" title="Video list" >
			<!--widget name="text" position="0,0" size="550,25" font="Regular;20" /-->
			<widget name="list" position="10,0" size="500,250" scrollbarMode="showOnDemand" />
			<!--widget name="pixmap" position="200,0" size="190,250" /-->
			<eLabel position="70,100" zPosition="-1" size="100,69" backgroundColor="#222222" />
			<widget name="info" position="100,230" zPosition="4" size="300,25" font="Regular;18" foregroundColor="#ffffff" transparent="1" halign="center" valign="center" />
		</screen>"""

    def __init__(self, session, url):
		self.skin = Searchurl.skin
		Screen.__init__(self, session)

        	self["list"] = MenuList([])
		self["info"] = Label()
                self["actions"] = ActionMap(["OkCancelActions"], {"ok": self.okClicked, "cancel": self.close}, -1)
                self.url = url
                
                self.onLayoutFinish.append(self.openTest)

    def openTest(self):
           self["info"].setText("Downloading list...")
           getPage(self.url).addCallback(self.downloadListCallback).addErrback(self.downloadListError)

    def downloadListError(self, error=""):
		print str(error)
		self["info"].setText("Connection Error!")

    def downloadListCallback(self, fpage=""):
           start = fpage.find("div class=\"searchResults")
     
           self.entry = []
           self.url1 = []
     
	   i = 0
	   icount = 0
	   while i<50 :
                pos1 = fpage.find("videoInfo\"><a href=", start)
                if (pos1 <0 ):
                      break          
                pos2 = fpage.find("&searchid", pos1+4)
                if (pos2 <0 ):
                      break    
                pos3 = fpage.find(">", (pos2+1))
                if (pos3 <0 ):
                      break  
                pos4 = fpage.find("</a><br/", (pos3+1))
                if (pos4 <0 ):
                      break 
                self.entry.append(i)
                self.entry[i] = fpage[(pos3+1):pos4]
                self.entry[i] = self.entry[i].replace("<b>", " ")
                self.entry[i] = self.entry[i].replace("</b>", " ")
                self.url1.append(i)
                self.url1[i] = fpage[(pos1+20):pos2]
                
                start = pos4 + 1
                i = i+1

           self["info"].setText("")
           self["list"].setList(self.entry)     

    def okClicked(self):
	        ientry = self["list"].getSelectionIndex()
                url = self.url1[ientry]
                name = self.entry[ientry]
                gvlc = Getvlc(self.session, name, url)
                gvlc.openTest()

    def keyLeft(self):
		self["text"].left()
	
    def keyRight(self):
		self["text"].right()
	
    def keyNumberGlobal(self, number):
		print "pressed", number
		self["text"].number(number)		
		
               
class Vlocation(Screen):
    skin = """
		<screen position="200,200" size="350,300" title="Language Zone" >
			<!--widget name="text" position="0,0" size="550,25" font="Regular;20" /-->
			<widget name="list" position="10,0" size="200,250" scrollbarMode="showOnDemand" />
			<!--widget name="pixmap" position="200,0" size="190,250" /-->
			<eLabel position="70,100" zPosition="-1" size="100,69" backgroundColor="#222222" />
			<widget name="info" position="100,230" zPosition="4" size="100,25" font="Regular;18" foregroundColor="#ffffff" transparent="1" halign="center" valign="center" />

		</screen>"""
    def __init__(self, session):
		self.skin = Vlocation.skin
		Screen.__init__(self, session)

        	self["list"] = MenuList([])
		self["info"] = Label()
                self["actions"] = ActionMap(["OkCancelActions"], {"ok": self.okClicked, "cancel": self.close}, -1)

                self.icount = 0
                self.onLayoutFinish.append(self.startSession)

    def startSession(self):
                language =[]
                self.lang = []
                i = 0
                while i<10:
                      language.append(i)
                      self.lang.append(i)
                      i = i+1
                
                language[0] = "English"
                language[1] = "Danish"
                language[2] = "Dutch"
                language[3] = "French"
                language[4] = "German"
                language[5] = "Hindi"
                language[6] = "Italian"
                language[7] = "Norwegian"
                language[8] = "Russian"
                language[9] = "Swedish"
             
                self.lang[0] = "en"
                self.lang[1] = "da"
                self.lang[2] = "nl"
                self.lang[3] = "fr"
                self.lang[4] = "de"
                self.lang[5] = "hi"
                self.lang[6] = "it"
                self.lang[7] = "nb"
                self.lang[8] = "ru"
                self.lang[9] = "sv"
   
                self["list"].setList(language)
    
    def okClicked(self):
		itype = self["list"].getSelectionIndex()
		langu = self.lang[itype]
		self.session.open(Vcategory, langu)


class Vcategory(Screen):
    skin = """
		<screen position="200,200" size="350,300" title="Video Category" >
			<!--widget name="text" position="0,0" size="550,25" font="Regular;20" /-->
			<widget name="list" position="10,0" size="200,250" scrollbarMode="showOnDemand" />
			<!--widget name="pixmap" position="200,0" size="190,250" /-->
			<eLabel position="70,100" zPosition="-1" size="100,69" backgroundColor="#222222" />
			<widget name="info" position="100,230" zPosition="4" size="100,25" font="Regular;18" foregroundColor="#ffffff" transparent="1" halign="center" valign="center" />

		</screen>"""
    def __init__(self, session, langu):
		self.skin = Vcategory.skin
		Screen.__init__(self, session, langu)

        	self["list"] = MenuList([])
		self["info"] = Label()
                self["actions"] = ActionMap(["OkCancelActions"], {"ok": self.okClicked, "cancel": self.close}, -1)

                self.language = langu
                self.icount = 0
                self.onLayoutFinish.append(self.startSession)

    def startSession(self):
                categ =[]
                self.cat = []
                i = 0
                while i<8:
                      categ.append(i)
                      self.cat.append(i)
                      i = i+1
                
                categ[0] = "All"
                categ[1] = "Music"
                categ[2] = "Sports"
                categ[3] = "Video games"
                categ[4] = "Science"
                categ[5] = "Extreme"
                categ[6] = "Humour"
                categ[7] = "Entertainment"
             
                self.cat[0] = "0"
                self.cat[1] = "9"
                self.cat[2] = "14"
                self.cat[3] = "16"
                self.cat[4] = "12"
                self.cat[5] = "6"
                self.cat[6] = "4"
                self.cat[7] = "5"
                
      
                self["list"].setList(categ)
    
    def okClicked(self):
		itype = self["list"].getSelectionIndex()
		cate = self.cat[itype]
		lang = self.language
		self.session.open(Vperiod, cate, lang)


class Vperiod(Screen):
    skin = """
		<screen position="200,200" size="350,300" title="Top rated for" >
			<!--widget name="text" position="0,0" size="550,25" font="Regular;20" /-->
			<widget name="list" position="10,0" size="200,250" scrollbarMode="showOnDemand" />
			<!--widget name="pixmap" position="200,0" size="190,250" /-->
			<eLabel position="70,100" zPosition="-1" size="100,69" backgroundColor="#222222" />
			<widget name="info" position="100,230" zPosition="4" size="100,25" font="Regular;18" foregroundColor="#ffffff" transparent="1" halign="center" valign="center" />

		</screen>"""
    def __init__(self, session, cate, lang):
		self.skin = Vperiod.skin
		Screen.__init__(self, session)

        	self["list"] = MenuList([])
		self["info"] = Label()
                self["actions"] = ActionMap(["OkCancelActions"], {"ok": self.okClicked, "cancel": self.close}, -1)

                self.category = cate
                self.language = lang
                self.icount = 0
                self.onLayoutFinish.append(self.startSession)

    def startSession(self):
                per =[]
                self.perd = []
                i = 0
                while i<4:
                      per.append(i)
                      self.perd.append(i)
                      i = i+1
                
                per[0] = "Today"
                per[1] = "Week"
                per[2] = "Month"
                per[3] = "All time"
             
                self.perd[0] = "1"
                self.perd[1] = "2"
                self.perd[2] = "3"
                self.perd[3] = "4"
   
                self["list"].setList(per)
    
    def okClicked(self):
		itype = self["list"].getSelectionIndex()
		peri = self.perd[itype]
		cate = self.category
		lang = self.language
		self.session.open(Geturl, peri, cate, lang)




class Geturl(Screen):

    skin = """
		<screen position="100,100" size="550,400" title="Video list" >
			<!--widget name="text" position="0,0" size="550,25" font="Regular;20" /-->
			<widget name="list" position="10,0" size="500,250" scrollbarMode="showOnDemand" />
			<!--widget name="pixmap" position="200,0" size="190,250" /-->
			<eLabel position="70,100" zPosition="-1" size="100,69" backgroundColor="#222222" />
			<widget name="info" position="100,230" zPosition="4" size="300,25" font="Regular;18" foregroundColor="#ffffff" transparent="1" halign="center" valign="center" />
		</screen>"""

    def __init__(self, session, peri, cate, lang):
		self.skin = Geturl.skin
		Screen.__init__(self, session)

        	self["list"] = MenuList([])
		self["info"] = Label()
                self["actions"] = ActionMap(["OkCancelActions"], {"ok": self.okClicked, "cancel": self.close}, -1)
                self.icount = 0
                self.period = peri
                self.category = cate
                self.language = lang                
                
                self.onLayoutFinish.append(self.openTest)

    def openTest(self):
           self["info"].setText("Downloading list...")
           url = "http://vids.myspace.com/index.cfm?fuseaction=vids.charts&category=" + self.category + "&show_for=" + self.period + "&view_by=4&language=" + self.language;

           getPage(url).addCallback(self.downloadListCallback).addErrback(self.downloadListError)

    def downloadListError(self, error=""):
		print str(error)
		self["info"].setText("Connection Error!")

    def downloadListCallback(self, fpage=""):
           iurl = []
           iname = []
           surl = []
           self.names = []
           self.urls = []
           start = fpage.find("divChartVideos")
           finish = fpage.find("pagecontrolWrapper", start)
     
           self.entry = []
           self.url1 = []
     
	   i = 0
	   icount = 0
	   while i<50 :
                    pos1 = fpage.find("<a title=", start)
                    if (pos1 == 0):
                           break
		    if (pos1 > finish):
                           break
 		    pos2 = fpage.find("href=", pos1+4)
 		    if (pos2 == 0):
                           break
                    pos3 = fpage.find("<strong>", pos2+1)
                    if (pos3 == 0):
                           break
                    pos4 = fpage.find("class=\"clear", pos3+1)
                    if (pos3 == 0):
                           break
		
                    self.entry.append(i)
                    self.url1.append(i)
                    self.entry[i] = fpage[(pos1+10):(pos2-2)]
                    self.url1[i] = "http://vids.myspace.com" + fpage[(pos2+6):(pos3-2)] 
                    
                    i = i+1
                    start = pos4 + 1;
           self.icount = 1
           self["info"].setText("")
           self["list"].setList(self.entry)

    def okClicked(self):
	        ientry = self["list"].getSelectionIndex()
                url = self.url1[ientry]
                name = self.entry[ientry]
                gvlc = Getvlc(self.session, name, url)
                gvlc.openTest()

    def keyLeft(self):
		self["text"].left()
	
    def keyRight(self):
		self["text"].right()
	
    def keyNumberGlobal(self, number):
		print "pressed", number
		self["text"].number(number)		
		




class Getvlc(Screen):

    skin = """
		<screen position="100,100" size="550,400" title="Getvlc" >
			<!--widget name="text" position="0,0" size="550,25" font="Regular;20" /-->
			<widget name="list" position="10,0" size="500,250" scrollbarMode="showOnDemand" />
			<!--widget name="pixmap" position="200,0" size="190,250" /-->
			<eLabel position="70,100" zPosition="-1" size="100,69" backgroundColor="#222222" />
			<widget name="info" position="100,230" zPosition="4" size="300,25" font="Regular;18" foregroundColor="#ffffff" transparent="1" halign="center" valign="center" />
		</screen>"""

    def __init__(self, session, name, url):
		self.skin = Getvlc.skin
		Screen.__init__(self, session)

        	self["list"] = MenuList([])
		self["info"] = Label()
                self["actions"] = ActionMap(["OkCancelActions"], {"ok": self.okClicked, "cancel": self.close}, -1)
                self.icount = 0
                self.name = name
                self.url = url
              
                
                self.onShown.append(self.openTest)
   
    
    def openTest(self):
            getPage(self.url).addCallback(self.downloadListCallback).addErrback(self.downloadListError)

    def downloadListError(self, error=""):
		print str(error)
		self["info"].setText("Connection Error!")

    def downloadListCallback(self, fpage=""):
           start = 0
           pos1 = fpage.find("video_src", start)
           pos2 = fpage.find("video_type", pos1+1)
           vidinfo = fpage[(pos1):(pos2)]
           pos3 = vidinfo.find("videos02", 1)
           if (pos3 < 0 ):
                pos4 = vidinfo.find("image_src", 1)
                pos5 = vidinfo.find("http://", pos4+1)
                pos6 = vidinfo.find("/", pos5+8)
                pos7 = vidinfo.find("/", pos6+1)
                pos8 = vidinfo.find("/", pos7+1)
                pos9 = vidinfo.find("/", pos8+1)
                pos10 = vidinfo.find("_thumb1.jpg", pos8+1)

                la = vidinfo[(pos7+1):(pos9)]
                lb = vidinfo[(pos9+1):(pos10)]

                lbt = "000" + lb
                lblen = len(lbt)
                if (lblen==12):
                     lkey = lbt[0:7]
                elif (lblen==13):
                     lkey = lbt[1:8]
                else:
                     self["info"].setText("Sorry! This video cannot be played")
                     return
                self.mrl = "http://content.movies.myspace.com/" + lkey + "/" + la + "/" + lb + ".flv";      
                
                self.test()
           else:

         	pos4 = vidinfo.find("videos02", 1)
 	        pos5 = vidinfo.find("thumb1_", pos4)
        	pos6 = vidinfo.find(".jpg", pos5+1)

                vid = vidinfo[(pos4+9):(pos5-1)]
                vkey = vidinfo[(pos5+7):(pos6)]
 
                self.mrl = "http://cache01-videos02.myspacecdn.com/" + vid + "/vid_" + vkey +".flv"; 
                self.test()



    def test(self):
        	self.serverList = vlcServerConfig.getServerlist()
         	if len(self.serverList) == 0:
			self.session.open(MessageBox, "No server configured in VlcPlayer Plugin!", MessageBox.TYPE_ERROR)
		elif len(self.serverList) == 1:
			self.playfile(0)
		else:
			self.playfile(0)
			
	
    def playfile(self, serverint):
		self.serverList[serverint].play(self.session, self.mrl, self.name)


    def keyLeft(self):
		self["text"].left()
	
    def keyRight(self):
		self["text"].right()
		
    def okClicked(self):
                return		
 
	
    def keyNumberGlobal(self, number):
		print "pressed", number
		self["text"].number(number)		
		
     

def main(session, **kwargs):
        session.open(Myspace)
        
		

def Plugins(**kwargs):
	return PluginDescriptor(name="MySpaceViewer", description="Streams videos from MySpace", 		where = [ PluginDescriptor.WHERE_EXTENSIONSMENU, PluginDescriptor.WHERE_PLUGINMENU ], fnc=main)



